/* Color.c generated by valac 0.16.1, the Vala compiler
 * generated from Color.vala, do not modify */

/*  */
/*  Copyright (C) 2011 Robert Dyer*/
/* */
/*  This program is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/* */
/*  This program is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/* */
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/* */

#include <glib.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <string.h>


#define SLINGSHOT_FRONTEND_TYPE_COLOR (slingshot_frontend_color_get_type ())
typedef struct _SlingshotFrontendColor SlingshotFrontendColor;

struct _SlingshotFrontendColor {
	gdouble R;
	gdouble G;
	gdouble B;
	gdouble A;
};



GType slingshot_frontend_color_get_type (void) G_GNUC_CONST;
SlingshotFrontendColor* slingshot_frontend_color_dup (const SlingshotFrontendColor* self);
void slingshot_frontend_color_free (SlingshotFrontendColor* self);
void slingshot_frontend_color_init (SlingshotFrontendColor *self, gdouble R, gdouble G, gdouble B, gdouble A);
void slingshot_frontend_color_set_val (SlingshotFrontendColor *self, gdouble val, SlingshotFrontendColor* result);
static void slingshot_frontend_color_rgb_to_hsv (SlingshotFrontendColor *self, gdouble r, gdouble g, gdouble b, gdouble* h, gdouble* s, gdouble* v);
static void slingshot_frontend_color_hsv_to_rgb (SlingshotFrontendColor *self, gdouble h, gdouble s, gdouble v, gdouble* r, gdouble* g, gdouble* b);
void slingshot_frontend_color_multiply_sat (SlingshotFrontendColor *self, gdouble amount, SlingshotFrontendColor* result);


void slingshot_frontend_color_init (SlingshotFrontendColor *self, gdouble R, gdouble G, gdouble B, gdouble A) {
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	memset (self, 0, sizeof (SlingshotFrontendColor));
	_tmp0_ = R;
	(*self).R = _tmp0_;
	_tmp1_ = G;
	(*self).G = _tmp1_;
	_tmp2_ = B;
	(*self).B = _tmp2_;
	_tmp3_ = A;
	(*self).A = _tmp3_;
}


void slingshot_frontend_color_set_val (SlingshotFrontendColor *self, gdouble val, SlingshotFrontendColor* result) {
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	gdouble _tmp7_ = 0.0;
	gdouble _tmp8_;
	gdouble _tmp9_;
	gdouble _tmp10_ = 0.0;
	gdouble _tmp11_ = 0.0;
	gdouble _tmp12_ = 0.0;
	_tmp0_ = val;
	_tmp1_ = val;
	g_return_if_fail ((_tmp0_ >= ((gdouble) 0)) && (_tmp1_ <= ((gdouble) 1)));
	_tmp2_ = (*self).R;
	_tmp3_ = (*self).G;
	_tmp4_ = (*self).B;
	slingshot_frontend_color_rgb_to_hsv (&(*self), _tmp2_, _tmp3_, _tmp4_, &_tmp5_, &_tmp6_, &_tmp7_);
	h = _tmp5_;
	s = _tmp6_;
	v = _tmp7_;
	_tmp8_ = val;
	v = _tmp8_;
	_tmp9_ = v;
	slingshot_frontend_color_hsv_to_rgb (&(*self), h, s, _tmp9_, &_tmp10_, &_tmp11_, &_tmp12_);
	(*self).R = _tmp10_;
	(*self).G = _tmp11_;
	(*self).B = _tmp12_;
	*result = (*self);
	return;
}


void slingshot_frontend_color_multiply_sat (SlingshotFrontendColor *self, gdouble amount, SlingshotFrontendColor* result) {
	gdouble _tmp0_;
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	gdouble _tmp7_;
	gdouble _tmp8_;
	gdouble _tmp9_ = 0.0;
	gdouble _tmp10_;
	gdouble _tmp11_ = 0.0;
	gdouble _tmp12_ = 0.0;
	gdouble _tmp13_ = 0.0;
	_tmp0_ = amount;
	g_return_if_fail (_tmp0_ >= ((gdouble) 0));
	_tmp1_ = (*self).R;
	_tmp2_ = (*self).G;
	_tmp3_ = (*self).B;
	slingshot_frontend_color_rgb_to_hsv (&(*self), _tmp1_, _tmp2_, _tmp3_, &_tmp4_, &_tmp5_, &_tmp6_);
	h = _tmp4_;
	s = _tmp5_;
	v = _tmp6_;
	_tmp7_ = s;
	_tmp8_ = amount;
	_tmp9_ = fmin ((gdouble) 1, _tmp7_ * _tmp8_);
	s = _tmp9_;
	_tmp10_ = s;
	slingshot_frontend_color_hsv_to_rgb (&(*self), h, _tmp10_, v, &_tmp11_, &_tmp12_, &_tmp13_);
	(*self).R = _tmp11_;
	(*self).G = _tmp12_;
	(*self).B = _tmp13_;
	*result = (*self);
	return;
}


static void slingshot_frontend_color_rgb_to_hsv (SlingshotFrontendColor *self, gdouble r, gdouble g, gdouble b, gdouble* h, gdouble* s, gdouble* v) {
	gdouble _vala_h = 0.0;
	gdouble _vala_s = 0.0;
	gdouble _vala_v = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_;
	gdouble _tmp9_ = 0.0;
	gdouble _tmp10_ = 0.0;
	gdouble min;
	gdouble _tmp11_;
	gdouble _tmp12_;
	gdouble _tmp13_;
	gdouble _tmp14_ = 0.0;
	gdouble _tmp15_ = 0.0;
	gdouble max;
	gdouble _tmp16_;
	gdouble _tmp17_;
	gdouble _tmp18_;
	gdouble _tmp19_;
	gdouble _tmp20_;
	gdouble _tmp21_;
	gdouble _tmp22_;
	gdouble _tmp23_;
	gdouble _tmp24_;
	gdouble _tmp25_;
	gdouble _tmp26_;
	gdouble _tmp27_ = 0.0;
	gdouble _tmp28_ = 0.0;
	gdouble _tmp29_;
	gdouble _tmp30_;
	gdouble _tmp31_;
	gdouble _tmp32_ = 0.0;
	gdouble _tmp33_ = 0.0;
	gdouble _tmp34_;
	gdouble _tmp35_;
	gdouble delta;
	gdouble _tmp36_;
	gdouble _tmp37_;
	gdouble _tmp38_;
	gdouble _tmp39_;
	gdouble _tmp40_;
	gdouble _tmp41_;
	gdouble _tmp42_;
	gdouble _tmp43_;
	gdouble _tmp44_;
	gdouble _tmp45_;
	gdouble _tmp46_;
	gdouble _tmp47_;
	gdouble _tmp48_;
	_tmp0_ = r;
	_tmp1_ = r;
	g_return_if_fail ((_tmp0_ >= ((gdouble) 0)) && (_tmp1_ <= ((gdouble) 1)));
	_tmp2_ = g;
	_tmp3_ = g;
	g_return_if_fail ((_tmp2_ >= ((gdouble) 0)) && (_tmp3_ <= ((gdouble) 1)));
	_tmp4_ = b;
	_tmp5_ = b;
	g_return_if_fail ((_tmp4_ >= ((gdouble) 0)) && (_tmp5_ <= ((gdouble) 1)));
	_tmp6_ = r;
	_tmp7_ = g;
	_tmp8_ = b;
	_tmp9_ = fmin (_tmp7_, _tmp8_);
	_tmp10_ = fmin (_tmp6_, _tmp9_);
	min = _tmp10_;
	_tmp11_ = r;
	_tmp12_ = g;
	_tmp13_ = b;
	_tmp14_ = fmax (_tmp12_, _tmp13_);
	_tmp15_ = fmax (_tmp11_, _tmp14_);
	max = _tmp15_;
	_tmp16_ = max;
	_vala_v = _tmp16_;
	_tmp17_ = _vala_v;
	if (_tmp17_ == ((gdouble) 0)) {
		_vala_h = (gdouble) 0;
		_vala_s = (gdouble) 0;
		if (h) {
			*h = _vala_h;
		}
		if (s) {
			*s = _vala_s;
		}
		if (v) {
			*v = _vala_v;
		}
		return;
	}
	_tmp18_ = r;
	_tmp19_ = _vala_v;
	r = _tmp18_ / _tmp19_;
	_tmp20_ = g;
	_tmp21_ = _vala_v;
	g = _tmp20_ / _tmp21_;
	_tmp22_ = b;
	_tmp23_ = _vala_v;
	b = _tmp22_ / _tmp23_;
	_tmp24_ = r;
	_tmp25_ = g;
	_tmp26_ = b;
	_tmp27_ = fmin (_tmp25_, _tmp26_);
	_tmp28_ = fmin (_tmp24_, _tmp27_);
	min = _tmp28_;
	_tmp29_ = r;
	_tmp30_ = g;
	_tmp31_ = b;
	_tmp32_ = fmax (_tmp30_, _tmp31_);
	_tmp33_ = fmax (_tmp29_, _tmp32_);
	max = _tmp33_;
	_tmp34_ = max;
	_tmp35_ = min;
	delta = _tmp34_ - _tmp35_;
	_tmp36_ = delta;
	_vala_s = _tmp36_;
	_tmp37_ = _vala_s;
	if (_tmp37_ == ((gdouble) 0)) {
		_vala_h = (gdouble) 0;
		if (h) {
			*h = _vala_h;
		}
		if (s) {
			*s = _vala_s;
		}
		if (v) {
			*v = _vala_v;
		}
		return;
	}
	_tmp38_ = r;
	_tmp39_ = min;
	_tmp40_ = delta;
	r = (_tmp38_ - _tmp39_) / _tmp40_;
	_tmp41_ = g;
	_tmp42_ = min;
	_tmp43_ = delta;
	g = (_tmp41_ - _tmp42_) / _tmp43_;
	_tmp44_ = b;
	_tmp45_ = min;
	_tmp46_ = delta;
	b = (_tmp44_ - _tmp45_) / _tmp46_;
	_tmp47_ = max;
	_tmp48_ = r;
	if (_tmp47_ == _tmp48_) {
		gdouble _tmp49_;
		gdouble _tmp50_;
		gdouble _tmp51_;
		_tmp49_ = g;
		_tmp50_ = b;
		_vala_h = 0 + (60 * (_tmp49_ - _tmp50_));
		_tmp51_ = _vala_h;
		if (_tmp51_ < ((gdouble) 0)) {
			gdouble _tmp52_;
			_tmp52_ = _vala_h;
			_vala_h = _tmp52_ + 360;
		}
	} else {
		gdouble _tmp53_;
		gdouble _tmp54_;
		_tmp53_ = max;
		_tmp54_ = g;
		if (_tmp53_ == _tmp54_) {
			gdouble _tmp55_;
			gdouble _tmp56_;
			_tmp55_ = b;
			_tmp56_ = r;
			_vala_h = 120 + (60 * (_tmp55_ - _tmp56_));
		} else {
			gdouble _tmp57_;
			gdouble _tmp58_;
			_tmp57_ = r;
			_tmp58_ = g;
			_vala_h = 240 + (60 * (_tmp57_ - _tmp58_));
		}
	}
	if (h) {
		*h = _vala_h;
	}
	if (s) {
		*s = _vala_s;
	}
	if (v) {
		*v = _vala_v;
	}
}


static void slingshot_frontend_color_hsv_to_rgb (SlingshotFrontendColor *self, gdouble h, gdouble s, gdouble v, gdouble* r, gdouble* g, gdouble* b) {
	gdouble _vala_r = 0.0;
	gdouble _vala_g = 0.0;
	gdouble _vala_b = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
	gdouble _tmp6_;
	_tmp0_ = h;
	_tmp1_ = h;
	g_return_if_fail ((_tmp0_ >= ((gdouble) 0)) && (_tmp1_ <= ((gdouble) 360)));
	_tmp2_ = s;
	_tmp3_ = s;
	g_return_if_fail ((_tmp2_ >= ((gdouble) 0)) && (_tmp3_ <= ((gdouble) 1)));
	_tmp4_ = v;
	_tmp5_ = v;
	g_return_if_fail ((_tmp4_ >= ((gdouble) 0)) && (_tmp5_ <= ((gdouble) 1)));
	_vala_r = (gdouble) 0;
	_vala_g = (gdouble) 0;
	_vala_b = (gdouble) 0;
	_tmp6_ = s;
	if (_tmp6_ == ((gdouble) 0)) {
		gdouble _tmp7_;
		gdouble _tmp8_;
		gdouble _tmp9_;
		_tmp7_ = v;
		_vala_r = _tmp7_;
		_tmp8_ = v;
		_vala_g = _tmp8_;
		_tmp9_ = v;
		_vala_b = _tmp9_;
	} else {
		gint secNum = 0;
		gdouble fracSec = 0.0;
		gdouble p = 0.0;
		gdouble q = 0.0;
		gdouble t = 0.0;
		gdouble _tmp10_;
		gdouble _tmp11_ = 0.0;
		gdouble _tmp12_;
		gint _tmp13_;
		gdouble _tmp14_;
		gdouble _tmp15_;
		gdouble _tmp16_;
		gdouble _tmp17_;
		gdouble _tmp18_;
		gdouble _tmp19_;
		gdouble _tmp20_;
		gdouble _tmp21_;
		gint _tmp22_;
		_tmp10_ = h;
		_tmp11_ = floor (_tmp10_ / 60);
		secNum = (gint) _tmp11_;
		_tmp12_ = h;
		_tmp13_ = secNum;
		fracSec = (_tmp12_ / 60) - _tmp13_;
		_tmp14_ = v;
		_tmp15_ = s;
		p = _tmp14_ * (1 - _tmp15_);
		_tmp16_ = v;
		_tmp17_ = s;
		_tmp18_ = fracSec;
		q = _tmp16_ * (1 - (_tmp17_ * _tmp18_));
		_tmp19_ = v;
		_tmp20_ = s;
		_tmp21_ = fracSec;
		t = _tmp19_ * (1 - (_tmp20_ * (1 - _tmp21_)));
		_tmp22_ = secNum;
		switch (_tmp22_) {
			case 0:
			{
				gdouble _tmp23_;
				gdouble _tmp24_;
				gdouble _tmp25_;
				_tmp23_ = v;
				_vala_r = _tmp23_;
				_tmp24_ = t;
				_vala_g = _tmp24_;
				_tmp25_ = p;
				_vala_b = _tmp25_;
				break;
			}
			case 1:
			{
				gdouble _tmp26_;
				gdouble _tmp27_;
				gdouble _tmp28_;
				_tmp26_ = q;
				_vala_r = _tmp26_;
				_tmp27_ = v;
				_vala_g = _tmp27_;
				_tmp28_ = p;
				_vala_b = _tmp28_;
				break;
			}
			case 2:
			{
				gdouble _tmp29_;
				gdouble _tmp30_;
				gdouble _tmp31_;
				_tmp29_ = p;
				_vala_r = _tmp29_;
				_tmp30_ = v;
				_vala_g = _tmp30_;
				_tmp31_ = t;
				_vala_b = _tmp31_;
				break;
			}
			case 3:
			{
				gdouble _tmp32_;
				gdouble _tmp33_;
				gdouble _tmp34_;
				_tmp32_ = p;
				_vala_r = _tmp32_;
				_tmp33_ = q;
				_vala_g = _tmp33_;
				_tmp34_ = v;
				_vala_b = _tmp34_;
				break;
			}
			case 4:
			{
				gdouble _tmp35_;
				gdouble _tmp36_;
				gdouble _tmp37_;
				_tmp35_ = t;
				_vala_r = _tmp35_;
				_tmp36_ = p;
				_vala_g = _tmp36_;
				_tmp37_ = v;
				_vala_b = _tmp37_;
				break;
			}
			case 5:
			{
				gdouble _tmp38_;
				gdouble _tmp39_;
				gdouble _tmp40_;
				_tmp38_ = v;
				_vala_r = _tmp38_;
				_tmp39_ = p;
				_vala_g = _tmp39_;
				_tmp40_ = q;
				_vala_b = _tmp40_;
				break;
			}
			default:
			break;
		}
	}
	if (r) {
		*r = _vala_r;
	}
	if (g) {
		*g = _vala_g;
	}
	if (b) {
		*b = _vala_b;
	}
}


SlingshotFrontendColor* slingshot_frontend_color_dup (const SlingshotFrontendColor* self) {
	SlingshotFrontendColor* dup;
	dup = g_new0 (SlingshotFrontendColor, 1);
	memcpy (dup, self, sizeof (SlingshotFrontendColor));
	return dup;
}


void slingshot_frontend_color_free (SlingshotFrontendColor* self) {
	g_free (self);
}


GType slingshot_frontend_color_get_type (void) {
	static volatile gsize slingshot_frontend_color_type_id__volatile = 0;
	if (g_once_init_enter (&slingshot_frontend_color_type_id__volatile)) {
		GType slingshot_frontend_color_type_id;
		slingshot_frontend_color_type_id = g_boxed_type_register_static ("SlingshotFrontendColor", (GBoxedCopyFunc) slingshot_frontend_color_dup, (GBoxedFreeFunc) slingshot_frontend_color_free);
		g_once_init_leave (&slingshot_frontend_color_type_id__volatile, slingshot_frontend_color_type_id);
	}
	return slingshot_frontend_color_type_id__volatile;
}



